Loading...
Searching...
No Matches
sparsmat.h File Reference

Go to the source code of this file.

## Macros

#define | SM_MULT sm_MultDiv
#define | SM_DIV sm_SpecialPolyDiv

## Functions

poly | sm_MultDiv (poly, poly, const poly, const ring)
void | sm_SpecialPolyDiv (poly, poly, const ring)
poly | sm_CallDet (ideal I, const ring)
void | sm_CallBareiss (ideal smat, int x, int y, ideal &M, intvec **iv, const ring)
ideal | sm_CallSolv (ideal I, const ring)
ring | sm_RingChange (const ring, long)
void | sm_KillModifiedRing (ring r)
long | sm_ExpBound (ideal, int, int, int, const ring)

## Macro Definition Documentation

## SM_DIV

#define SM_DIV sm_SpecialPolyDiv

Definition at line 24 of file sparsmat.h.

## SM_MULT

#define SM_MULT sm_MultDiv

Definition at line 23 of file sparsmat.h.

## Function Documentation

## sm_CallBareiss()

void sm_CallBareiss | ( | ideal | smat,
|  | int | x,
|  | int | y,
|  | ideal & | M,
|  | intvec ** | iv,
|  | const ring | R )

Definition at line 347 of file sparsmat.cc.

{
int r=id_RankFreeModule(I,R),t=r;
int c=IDELEMS(I),s=c;
long bound;
ring tmpR;
sparse_mat *bareiss;
if ((x>0) && (x<t))
t-=x;
if ((y>1) && (y<s))
s-=y;
if (t>s) t=s;
bound=sm_ExpBound(I,c,r,t,R);
tmpR=sm_RingChange(R,bound);
ideal II = idrCopyR(I, R, tmpR);
bareiss = new sparse_mat(II,tmpR);
if (bareiss->smGetAct() == NULL)
{
delete bareiss;
*iv=new intvec(1,rVar(tmpR));
}
else
{
id_Delete(&II,tmpR);
bareiss->smNewBareiss(x, y);
II = bareiss->smRes2Mod();
*iv = new intvec(bareiss->smGetRed());
bareiss->smToIntvec(*iv);
delete bareiss;
II = idrMoveR(II,tmpR,R);
}
sm_KillModifiedRing(tmpR);
M=II;
}
x
Variable x
Definition cfModGcd.cc:4090
bound
static CanonicalForm bound(const CFMatrix &M)
Definition cf_linsys.cc:460
intvec
Definition intvec.h:24
sparse_mat
Definition sparsmat.cc:124
sparse_mat::smToIntvec
void smToIntvec(intvec *)
Definition sparsmat.cc:464
sparse_mat::smGetRed
int smGetRed()
Definition sparsmat.cc:173
sparse_mat::smGetAct
smpoly * smGetAct()
Definition sparsmat.cc:172
sparse_mat::smNewBareiss
void smNewBareiss(int, int)
Definition sparsmat.cc:549
sparse_mat::smRes2Mod
ideal smRes2Mod()
Definition sparsmat.cc:448
s
const CanonicalForm int s
Definition facAbsFact.cc:51
y
const CanonicalForm int const CFList const Variable & y
Definition facAbsFact.cc:53
NULL
#define NULL
Definition omList.c:12
idrMoveR
ideal idrMoveR(ideal &id, ring src_r, ring dest_r)
Definition prCopy.cc:248
idrCopyR
ideal idrCopyR(ideal id, ring src_r, ring dest_r)
Definition prCopy.cc:192
rVar
static short rVar(const ring r)
define rVar(r) (r->N)
Definition ring.h:598
id_Delete
void id_Delete(ideal *h, ring r)
deletes an ideal/module/matrix
Definition simpleideals.cc:123
id_RankFreeModule
long id_RankFreeModule(ideal s, ring lmRing, ring tailRing)
return the maximal component number found in any polynomial in s
Definition simpleideals.cc:992
IDELEMS
#define IDELEMS(i)
Definition simpleideals.h:23
R
#define R
Definition sirandom.c:27
M
#define M
Definition sirandom.c:25
sm_ExpBound
long sm_ExpBound(ideal m, int di, int ra, int t, const ring currRing)
Definition sparsmat.cc:188
sm_RingChange
ring sm_RingChange(const ring origR, long bound)
Definition sparsmat.cc:258
sm_KillModifiedRing
void sm_KillModifiedRing(ring r)
Definition sparsmat.cc:289

## sm_CallDet()

poly sm_CallDet | ( | ideal | I,
|  | const ring | R )

Definition at line 302 of file sparsmat.cc.

{
if (I->ncols != I->rank)
{
Werror("det of %ld x %d module (matrix)",I->rank,I->ncols);
return NULL;
}
int r=id_RankFreeModule(I,R);
if (I->ncols != r) // some 0-lines at the end
{
return NULL;
}
long bound=sm_ExpBound(I,r,r,r,R);
number diag,h=n_Init(1,R->cf);
poly res;
ring tmpR;
sparse_mat *det;
ideal II;
tmpR=sm_RingChange(R,bound);
II = idrCopyR(I, R, tmpR);
diag = sm_Cleardenom(II,tmpR);
det = new sparse_mat(II,tmpR);
id_Delete(&II,tmpR);
if (det->smGetAct() == NULL)
{
delete det;
sm_KillModifiedRing(tmpR);
return NULL;
}
res=det->smDet();
if(det->smGetSign()<0) res=p_Neg(res,tmpR);
delete det;
res = prMoveR(res, tmpR, R);
sm_KillModifiedRing(tmpR);
if (!n_Equal(diag,h,R->cf))
{
p_Mult_nn(res,diag,R);
p_Normalize(res,R);
}
n_Delete(&diag,R->cf);
n_Delete(&h,R->cf);
return res;
}
sparse_mat::smGetSign
int smGetSign()
Definition sparsmat.cc:171
sparse_mat::smDet
poly smDet()
Definition sparsmat.cc:475
n_Delete
static FORCE_INLINE void n_Delete(number *p, const coeffs r)
delete 'p'
Definition coeffs.h:461
n_Init
static FORCE_INLINE number n_Init(long i, const coeffs r)
a number representing i in the given coeff field/ring r
Definition coeffs.h:541
n_Equal
static FORCE_INLINE BOOLEAN n_Equal(number a, number b, const coeffs r)
TRUE iff 'a' and 'b' represent the same number; they may have different representations.
Definition coeffs.h:466
res
CanonicalForm res
Definition facAbsFact.cc:60
h
STATIC_VAR Poly * h
Definition janet.cc:971
p_Normalize
void p_Normalize(poly p, const ring r)
Definition p_polys.cc:3939
p_Neg
static poly p_Neg(poly p, const ring r)
Definition p_polys.h:1114
p_Mult_nn
static poly p_Mult_nn(poly p, number n, const ring r)
Definition p_polys.h:960
prMoveR
poly prMoveR(poly &p, ring src_r, ring dest_r)
Definition prCopy.cc:90
Werror
void Werror(const char *fmt,...)
Definition reporter.cc:189
sm_Cleardenom
static number sm_Cleardenom(ideal, const ring)
Definition sparsmat.cc:2223

## sm_CallSolv()

ideal sm_CallSolv | ( | ideal | I,
|  | const ring | R )

Definition at line 2316 of file sparsmat.cc.

{
sparse_number_mat *linsolv;
ring tmpR;
ideal rr;
if (id_IsConstant(I,R)==FALSE)
{
WerrorS("symbol in equation");
return NULL;
}
I->rank = id_RankFreeModule(I,R);
if (smCheckSolv(I)) return NULL;
tmpR=sm_RingChange(R,1);
rr=idrCopyR(I,R, tmpR);
linsolv = new sparse_number_mat(rr,tmpR);
rr=NULL;
linsolv->smTriangular();
if (linsolv->smIsSing() == 0)
{
linsolv->smSolv();
rr = linsolv->smRes2Ideal();
}
else
WerrorS("singular problem for linsolv");
delete linsolv;
if (rr!=NULL)
rr = idrMoveR(rr,tmpR,R);
sm_KillModifiedRing(tmpR);
return rr;
}
FALSE
#define FALSE
Definition auxiliary.h:97
sparse_number_mat
Definition sparsmat.cc:2275
sparse_number_mat::smIsSing
int smIsSing()
Definition sparsmat.cc:2303
sparse_number_mat::smRes2Ideal
ideal smRes2Ideal()
Definition sparsmat.cc:2506
sparse_number_mat::smTriangular
void smTriangular()
Definition sparsmat.cc:2398
sparse_number_mat::smSolv
void smSolv()
Definition sparsmat.cc:2429
WerrorS
void WerrorS(const char *s)
Definition feFopen.cc:24
id_IsConstant
BOOLEAN id_IsConstant(ideal id, const ring r)
test if the ideal has only constant polynomials NOTE: zero ideal/module is also constant
Definition simpleideals.cc:529
smCheckSolv
static BOOLEAN smCheckSolv(ideal)
Definition sparsmat.cc:2889

## sm_ExpBound()

long sm_ExpBound | ( | ideal | m,
|  | int | di,
|  | int | ra,
|  | int | t,
|  | const ring | currRing )

Definition at line 188 of file sparsmat.cc.

{
poly p;
long kr, kc;
long *r, *c;
int al, bl, i, j, k;
if (ra==0) ra=1;
al = di*sizeof(long);
c = (long *)omAlloc(al);
bl = ra*sizeof(long);
r = (long *)omAlloc0(bl);
for (i=di-1;i>=0;i--)
{
kc = 0;
p = m->m[i];
while(p!=NULL)
{
k = p_GetComp(p, currRing)-1;
kr = r[k];
for (j=currRing->N;j>0;j--)
{
long t=p_GetExp(p,j, currRing);
if(t /*p_GetExp(p,j, currRing)*/ >kc)
kc=t; /*p_GetExp(p,j, currRing);*/
if(t /*p_GetExp(p,j, currRing)s*/ >kr)
kr=t; /*p_GetExp(p,j, currRing);*/
}
r[k] = kr;
pIter(p);
}
c[i] = kc;
}
if (t<di) smMinSelect(c, t, di);
if (t<ra) smMinSelect(r, t, ra);
kr = kc = 0;
for (j=t-1;j>=0;j--)
{
kr += r[j];
kc += c[j];
}
omFreeSize((ADDRESS)c, al);
omFreeSize((ADDRESS)r, bl);
if (kr<kc) kc = kr;
if (kr<1) kr = 1;
return kr;
}
ADDRESS
void * ADDRESS
Definition auxiliary.h:120
m
int m
Definition cfEzgcd.cc:128
i
int i
Definition cfEzgcd.cc:132
k
int k
Definition cfEzgcd.cc:99
p
int p
Definition cfModGcd.cc:4086
j
int j
Definition facHensel.cc:110
p_GetComp
#define p_GetComp(p, r)
Definition monomials.h:64
pIter
#define pIter(p)
Definition monomials.h:37
omFreeSize
#define omFreeSize(addr, size)
Definition omAllocDecl.h:260
omAlloc
#define omAlloc(size)
Definition omAllocDecl.h:210
omAlloc0
#define omAlloc0(size)
Definition omAllocDecl.h:211
p_GetExp
static long p_GetExp(const poly p, const unsigned long iBitmask, const int VarOffset)
get a single variable exponent @Note: the integer VarOffset encodes:
Definition p_polys.h:471
currRing
VAR ring currRing
Widely used global variable which specifies the current polynomial ring for Singular interpreter and ...
Definition polys.cc:13
smMinSelect
static void smMinSelect(long *, int, int)
Definition sparsmat.cc:236

## sm_KillModifiedRing()

void sm_KillModifiedRing | ( | ring | r | ) |

Definition at line 289 of file sparsmat.cc.

{
if (r->qideal!=NULL) id_Delete(&(r->qideal),r);
for(int i=r->N-1;i>=0;i--) omFree(r->names[i]);
omFreeSize(r->names,r->N*sizeof(char*));
rKillModifiedRing(r);
}
omFree
#define omFree(addr)
Definition omAllocDecl.h:261
rKillModifiedRing
void rKillModifiedRing(ring r)
Definition ring.cc:3119

## sm_MultDiv()

poly sm_MultDiv | ( | poly | a,
|  | poly | b,
|  | const poly | c,
|  | const ring | R )

Definition at line 1759 of file sparsmat.cc.

{
poly pa, e, res, r;
BOOLEAN lead;
if ((c == NULL) || p_LmIsConstantComp(c,R))
{
return pp_Mult_qq(a, b, R);
}
if (smSmaller(a, b))
{
r = a;
a = b;
b = r;
}
res = NULL;
e = p_Init(R);
lead = FALSE;
while (!lead)
{
pSetCoeff0(e,pGetCoeff(b));
if (sm_IsNegQuot(e, b, c, R))
{
lead = p_LmDivisibleByNoComp(e, a, R);
r = sm_SelectCopy_ExpMultDiv(a, e, b, c, R);
}
else
{
lead = TRUE;
r = pp_Mult_mm(a, e,R);
}
if (lead)
{
if (res != NULL)
{
sm_FindRef(&pa, &res, r, R);
if (pa == NULL)
lead = FALSE;
}
else
{
pa = res = r;
}
}
else
res = p_Add_q(res, r, R);
pIter(b);
if (b == NULL)
{
p_LmFree(e, R);
return res;
}
}
do
{
pSetCoeff0(e,pGetCoeff(b));
if (sm_IsNegQuot(e, b, c, R))
{
r = sm_SelectCopy_ExpMultDiv(a, e, b, c, R);
if (p_LmDivisibleByNoComp(e, a,R))
sm_CombineChain(&pa, r, R);
else
pa = p_Add_q(pa,r,R);
}
else
{
r = pp_Mult_mm(a, e, R);
sm_CombineChain(&pa, r, R);
}
pIter(b);
} while (b != NULL);
p_LmFree(e, R);
return res;
}
BOOLEAN
int BOOLEAN
Definition auxiliary.h:88
TRUE
#define TRUE
Definition auxiliary.h:101
b
CanonicalForm b
Definition cfModGcd.cc:4111
pa
static BOOLEAN pa(leftv res, leftv args)
Definition cohomo.cc:3770
pSetCoeff0
#define pSetCoeff0(p, n)
Definition monomials.h:59
pGetCoeff
static number & pGetCoeff(poly p)
return an alias to the leading coefficient of p assumes that p != NULL NOTE: not copy
Definition monomials.h:44
p_Add_q
static poly p_Add_q(poly p, poly q, const ring r)
Definition p_polys.h:938
pp_Mult_mm
static poly pp_Mult_mm(poly p, poly m, const ring r)
Definition p_polys.h:1033
p_LmIsConstantComp
static BOOLEAN p_LmIsConstantComp(const poly p, const ring r)
Definition p_polys.h:1008
p_LmDivisibleByNoComp
static BOOLEAN p_LmDivisibleByNoComp(poly a, poly b, const ring r)
Definition p_polys.h:1898
pp_Mult_qq
static poly pp_Mult_qq(poly p, poly q, const ring r)
Definition p_polys.h:1167
p_LmFree
static void p_LmFree(poly p, ring)
Definition p_polys.h:685
p_Init
static poly p_Init(const ring r, omBin bin)
Definition p_polys.h:1341
sm_CombineChain
static void sm_CombineChain(poly *, poly, const ring)
Definition sparsmat.cc:1973
smSmaller
static BOOLEAN smSmaller(poly, poly)
Definition sparsmat.cc:1962
sm_SelectCopy_ExpMultDiv
static poly sm_SelectCopy_ExpMultDiv(poly p, poly m, poly a, poly b, const ring currRing)
Definition sparsmat.cc:98
sm_IsNegQuot
static BOOLEAN sm_IsNegQuot(poly, const poly, const poly, const ring)
Definition sparsmat.cc:1906
sm_FindRef
static void sm_FindRef(poly *, poly *, poly, const ring)
Definition sparsmat.cc:2020

## sm_RingChange()

ring sm_RingChange | ( | const ring | origR,
|  | long | bound )

Definition at line 258 of file sparsmat.cc.

{
// *origR =currRing;
ring tmpR=rCopy0(origR,FALSE,FALSE);
rRingOrder_t *ord=(rRingOrder_t*)omAlloc0(3*sizeof(rRingOrder_t));
int *block0=(int*)omAlloc0(3*sizeof(int));
int *block1=(int*)omAlloc0(3*sizeof(int));
ord[0]=ringorder_c;
ord[1]=ringorder_dp;
tmpR->order=ord;
tmpR->OrdSgn=1;
block0[1]=1;
tmpR->block0=block0;
block1[1]=tmpR->N;
tmpR->block1=block1;
tmpR->bitmask = 2*bound;
tmpR->wvhdl = (int **)omAlloc0((3) * sizeof(int*));
// ???
// if (tmpR->bitmask > currRing->bitmask) tmpR->bitmask = currRing->bitmask;
rComplete(tmpR,1);
if (origR->qideal!=NULL)
{
tmpR->qideal= idrCopyR_NoSort(origR->qideal, origR, tmpR);
}
if (TEST_OPT_PROT)
Print("[%ld:%d]", (long) tmpR->bitmask, tmpR->ExpL_Size);
return tmpR;
}
Print
#define Print
Definition emacs.cc:80
TEST_OPT_PROT
#define TEST_OPT_PROT
Definition options.h:105
idrCopyR_NoSort
ideal idrCopyR_NoSort(ideal id, ring src_r, ring dest_r)
Definition prCopy.cc:205
rComplete
BOOLEAN rComplete(ring r, int force)
this needs to be called whenever a new ring is created: new fields in ring are created (like VarOffse...
Definition ring.cc:3527
rCopy0
ring rCopy0(const ring r, BOOLEAN copy_qideal, BOOLEAN copy_ordering)
Definition ring.cc:1427
rRingOrder_t
rRingOrder_t
order stuff
Definition ring.h:69
ringorder_dp
@ ringorder_dp
Definition ring.h:79
ringorder_c
@ ringorder_c
Definition ring.h:73

## sm_SpecialPolyDiv()

void sm_SpecialPolyDiv | ( | poly | a,
|  | poly | b,
|  | const ring | R )

Definition at line 1840 of file sparsmat.cc.

{
if (pNext(b) == NULL)
{
sm_PolyDivN(a, pGetCoeff(b),R);
return;
}
sm_ExactPolyDiv(a, b, R);
}
pNext
#define pNext(p)
Definition monomials.h:36
sm_ExactPolyDiv
static void sm_ExactPolyDiv(poly, poly, const ring)
Definition sparsmat.cc:1851
sm_PolyDivN
static void sm_PolyDivN(poly, const number, const ring)
Definition sparsmat.cc:1949